"use strict";

// Import dependencies
import("/js/core.js").then(() =>
	import("/js/damper.js").then(() =>
		import("/js/telegram.js").then(() => {
			const dependencies = setInterval(() => {
				if (
					typeof core === "function" &&
					typeof core.damper === "function" &&
					typeof core.telegram === "function"
				) {
					clearInterval(dependencies);
					clearTimeout(timeout);
					initialization();
				}
			}, 10);
			const timeout = setTimeout(() => {
				clearInterval(dependencies);
				initialization();
			}, 5000);

			function initialization() {
				if (typeof core.session === "undefined") {
					// Not initialized

					// Write to the core
					core.session = class session {
						/**
						 * Send data of Telegram program settings to the session
						 *
						 * @return {void}
						 */
						static telegram() {
							//
							const { initData, initDataUnsafe, ...data } = core.telegram.api;

							core.request(
								"/session/write",
								"telegram=" + JSON.stringify(data),
							);
						}
					};
				}
			}
		})
	)
);
